<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=big5">
</head>
<body>
<!-- #include file=UTF8Filer.asp -->
<%
' UTF8Filer Structured Text Demo
' Written by Hunter Beanland
' http://www.geocities.com/hbeanland/
' hbeanland@yahoo.com.au

' UTF8Filer is a class which can read and write UTF-8 (Mixed Byte) files being raw text, Delimited (CSV, Tab etc) or Fixed Width data files. 
' It includes functions to convert to and from Unicode as well as some useful mixed byte text handling functions.
' ASP (pre .NET) does not support mixed byte files or text streams - only pure Single Byte and Unicode, so we need use this class to help us out
' Full Microsoft Excel delimited rules are also adhered to:
' Text including commas & tabs encapsulated in double quotes are treated as 1 field ("text,text" = text,text)
' Double quotes used in encapsulation are stripped ("Text" = Text)
' 2 sets of double quotes are treated as 1 set of double quotes ("" = escaped ")
' Text in quotes can run over several lines
' Fields are outputed in a variable length single dimension array & inputed via the same.

'We must set ASP's codepage to Trad. Chinese - big5 (# 950) so it knows what we are working with. (The demo data file is in Chinese)
'Failure to set this correctly will show ??? instead of the chars.
'LCID is not required, but if you where playing in Trad. Chinese, it is better to set the LCID to Taiwan.
Session.CodePage = 950
'Session.LCID = &H0404

'Create an instance of the UTF8Filer class to read the data file.
Dim MyUTF8File, MyUTF8CSVFile, ArrayIndex, MyLocalFields
Set MyUTF8File = New UTF8Filer
'Create an instance of the UTF8Filer class to write to the CSV file.
Set MyUTF8CSVFile = New UTF8Filer

'We now set the class's charset to "big5". This is a seperate setting to the CodePage above.
MyUTF8File.UnicodeCharset = "big5"
MyUTF8CSVFile.UnicodeCharset = "big5"
'These are the column widths in the fixed width demo file. Use a comma (CSV) for the output file
MyUTF8File.FieldWidths = "15,4,30,16,2,10,20,20,20,20,20,20,10,30,120,20,40,80,100,100,100,100"
MyUTF8CSVFile.Delimiter = ","

'Open the Demo CSV file with error checking
Response.Write("<font face='arial'><b>UTF-8 Fixed Width File Demo</b><p>")
Response.Write("NOTE: This demo uses Traditional Chinese (big5) Character set. If this is not installed on your PC, then you will just see a jumble of Ascii characters (but the demo will work).<p>")
Response.Write("<b>Opening input UTF-8 Fixed Width file:</b> demo-fixed-tc.txt<p>")
if not MyUTF8File.LoadFile("demo-fixed-tc.txt") then
	'The filenames are stored here during the open process
	Response.Write(MyUTF8File.AbsoluteFileName & " (" & MyUTF8File.VirtualFileName & ")<br>")
	Response.Write(MyUTF8File.ErrorText & "<br>")
end if

'Display the contents on screen
Response.Write("<table>")
Response.flush
While not MyUTF8File.EOF
	MyLocalFields = MyUTF8File.ReadLine
	Response.Write("<tr>")
	For ArrayIndex = 0 to ubound(MyLocalFields,1)
		'Fixed width can have a lot of space around each field. 
		'Remember not to use any ASP/VBScript functions or display the data unless it is converted to Unicode first
		MyLocalFields(ArrayIndex) = Trim(MyUTF8File.cUTF82Unicode(MyLocalFields(ArrayIndex)))	
		Response.Write("<td>" & server.HTMLEncode(MyLocalFields(ArrayIndex)) & "</td>")
	Next
	Response.Write("</tr>" & vbCRLF)
	'Write the line to the output file
	MyUTF8CSVFile.WriteLine(MyLocalFields)
Wend
Response.Write("</table>")

'Save the CSV file
Response.Write("<b>Saving output UTF-8 CSV file:</b> demo-fixed-tc.csv<p>")
if not MyUTF8CSVFile.SaveFile("demo-fixed-tc.csv") then
	'The filenames are stored here during the open process
	Response.Write(MyUTF8CSVFile.AbsoluteFileName & " (" & MyUTF8CSVFile.VirtualFileName & ")<br>")
	Response.Write(MyUTF8CSVFile.ErrorText & "<br>")
end if

'Cleanup
set MyUTF8File = nothing
set MyUTF8CSVFile = nothing

%>
</body>
</html>